
.global hook_task5
hook_task5:

push {r4,lr}

mov  r4,r0
cmp  r0,#0xc8
beq  handle_c8
ldr  r1,_msg_724
sub  r1,r0,r1
cmp  r1,#1
bhi  process

ldr  r0,_lights_owner
ldrb r0,[r0]
cmp  r0,#2
beq  process

bl   get_setting        @ handle_724 + handle_725
cmp  r0,#3
bne  process            @ not in charger mode
ldr  r0,_msg_1b5c
cmp  r1,#0
beq  charger_plugged    @ charger plugged, switch lights on
ldr  r0,_msg_596        @ charger unplugged, (fade) lights out
charger_plugged:
bl   send_message

process:
mov  r0,r4

.global hook_task5_code
hook_task5_code:
nop
nop

mov  r1,r4
mov  r4,r0
ldr  r0,_msg_1388
cmp  r0,r4
beq  handle_1388        @ incoming call
ldr  r0,_msg_1b5c
sub  r0,r4,r0
beq  handle_1b5c
cmp  r0,#1
beq  handle_1b5d
cmp  r0,#2
bne  handle_end

handle_1388:            @ + handle_1b5e (lights master)
ldr  r0,_power
strb r4,[r0]            @ set power non-zero

handle_end:
mov  r0,r4

pop  {r4,pc}

handle_1b5c:
ldr  r0,_lights_owner
ldrb r0,[r0]
cmp  r0,#2
beq  handle_end
bl   get_setting
cmp  r0,#0
bne  handle_end
ldr  r0,_power
ldrb r0,[r0]
cmp  r0,#0
bne  handle_end         @ power non-zero, allow light
ldr  r0,_msg_1b5c
add  r0,#1
b    send_msg

handle_1b5d:
ldr  r0,_msg_596
sub  r1,r0,r1           @ we clear the <power> flag only if 1b5d was caused by 596 (lights timer reached 0)
bne  skip0              @ thanks to this 5210 can generate 1b5c/d while playing ringtones
ldr  r0,_power
strb r1,[r0]            @ set power 0
skip0:
ldr  r0,_lights_owner
ldrb r0,[r0]
cmp  r0,#2
beq  handle_end
bl   get_setting
cmp  r0,#1
beq  always_on
cmp  r0,#3
bne  handle_end
ldr  r0,_charger_status  @ non-zero when charger present
ldrb r0,[r0]
cmp  r0,#0
beq  handle_end
always_on:
ldr  r0,_msg_1b5c
send_msg:
bl   send_message
mov  r4,#0xdc
b    handle_end

handle_c8:
ldr  r0,_msg_argv
ldr  r0,[r0,#0]
cmp  r0,#0xd
bne  process
ldr  r0,_power          @ power key pressed
strb r4,[r0]            @ set power non-zero
b    process

get_setting:
push {r1,lr}
ldr  r0,_config_id
ldr  r1,_current_profile
ldrb r1,[r1]
bl   own_get_profile
pop  {r1,pc}

.align

_msg_1b5c:
.long 0x1b5c

_msg_1388:
.long 0x1388

_msg_596:
.long 0x596

_msg_724:
.long 0x724

@_msg_9b5a:
@.long 0x9b5a

_power:
.long power

_config_id:
.long config_id

_msg_argv:
.long msg_argv

_lights_owner:
.long lights_owner

_current_profile:
.long current_profile

_charger_status:
.long charger_status

@_id_lights_timer:
@.long id_lights_timer

@_light_timeout:
@.long light_timeout

.bss

power:
.space 1

